#include "lua_cocos2dx_cw_auto.hpp"
#include "CWCsb.h"
#include "scripting/lua-bindings/manual/tolua_fix.h"
#include "scripting/lua-bindings/manual/LuaBasicConversions.h"

int lua_cocos2dx_cw_CWCsb_getCsbFile(lua_State* tolua_S)
{
    int argc = 0;
    cocos2d::ui::CWCsb* cobj = nullptr;
    bool ok  = true;

#if COCOS2D_DEBUG >= 1
    tolua_Error tolua_err;
#endif


#if COCOS2D_DEBUG >= 1
    if (!tolua_isusertype(tolua_S,1,"ccui.CWCsb",0,&tolua_err)) goto tolua_lerror;
#endif

    cobj = (cocos2d::ui::CWCsb*)tolua_tousertype(tolua_S,1,0);

#if COCOS2D_DEBUG >= 1
    if (!cobj) 
    {
        tolua_error(tolua_S,"invalid 'cobj' in function 'lua_cocos2dx_cw_CWCsb_getCsbFile'", nullptr);
        return 0;
    }
#endif

    argc = lua_gettop(tolua_S)-1;
    if (argc == 0) 
    {
        if(!ok)
        {
            tolua_error(tolua_S,"invalid arguments in function 'lua_cocos2dx_cw_CWCsb_getCsbFile'", nullptr);
            return 0;
        }
        const std::string& ret = cobj->getCsbFile();
        tolua_pushcppstring(tolua_S,ret);
        return 1;
    }
    luaL_error(tolua_S, "%s has wrong number of arguments: %d, was expecting %d \n", "ccui.CWCsb:getCsbFile",argc, 0);
    return 0;

#if COCOS2D_DEBUG >= 1
    tolua_lerror:
    tolua_error(tolua_S,"#ferror in function 'lua_cocos2dx_cw_CWCsb_getCsbFile'.",&tolua_err);
#endif

    return 0;
}
int lua_cocos2dx_cw_CWCsb_init(lua_State* tolua_S)
{
    int argc = 0;
    cocos2d::ui::CWCsb* cobj = nullptr;
    bool ok  = true;

#if COCOS2D_DEBUG >= 1
    tolua_Error tolua_err;
#endif


#if COCOS2D_DEBUG >= 1
    if (!tolua_isusertype(tolua_S,1,"ccui.CWCsb",0,&tolua_err)) goto tolua_lerror;
#endif

    cobj = (cocos2d::ui::CWCsb*)tolua_tousertype(tolua_S,1,0);

#if COCOS2D_DEBUG >= 1
    if (!cobj) 
    {
        tolua_error(tolua_S,"invalid 'cobj' in function 'lua_cocos2dx_cw_CWCsb_init'", nullptr);
        return 0;
    }
#endif

    argc = lua_gettop(tolua_S)-1;
    if (argc == 0) 
    {
        if(!ok)
        {
            tolua_error(tolua_S,"invalid arguments in function 'lua_cocos2dx_cw_CWCsb_init'", nullptr);
            return 0;
        }
        bool ret = cobj->init();
        tolua_pushboolean(tolua_S,(bool)ret);
        return 1;
    }
    luaL_error(tolua_S, "%s has wrong number of arguments: %d, was expecting %d \n", "ccui.CWCsb:init",argc, 0);
    return 0;

#if COCOS2D_DEBUG >= 1
    tolua_lerror:
    tolua_error(tolua_S,"#ferror in function 'lua_cocos2dx_cw_CWCsb_init'.",&tolua_err);
#endif

    return 0;
}
int lua_cocos2dx_cw_CWCsb_setCsbFile(lua_State* tolua_S)
{
    int argc = 0;
    cocos2d::ui::CWCsb* cobj = nullptr;
    bool ok  = true;

#if COCOS2D_DEBUG >= 1
    tolua_Error tolua_err;
#endif


#if COCOS2D_DEBUG >= 1
    if (!tolua_isusertype(tolua_S,1,"ccui.CWCsb",0,&tolua_err)) goto tolua_lerror;
#endif

    cobj = (cocos2d::ui::CWCsb*)tolua_tousertype(tolua_S,1,0);

#if COCOS2D_DEBUG >= 1
    if (!cobj) 
    {
        tolua_error(tolua_S,"invalid 'cobj' in function 'lua_cocos2dx_cw_CWCsb_setCsbFile'", nullptr);
        return 0;
    }
#endif

    argc = lua_gettop(tolua_S)-1;
    if (argc == 1) 
    {
        std::string arg0;

        ok &= luaval_to_std_string(tolua_S, 2,&arg0, "ccui.CWCsb:setCsbFile");
        if(!ok)
        {
            tolua_error(tolua_S,"invalid arguments in function 'lua_cocos2dx_cw_CWCsb_setCsbFile'", nullptr);
            return 0;
        }
        cobj->setCsbFile(arg0);
        lua_settop(tolua_S, 1);
        return 1;
    }
    luaL_error(tolua_S, "%s has wrong number of arguments: %d, was expecting %d \n", "ccui.CWCsb:setCsbFile",argc, 1);
    return 0;

#if COCOS2D_DEBUG >= 1
    tolua_lerror:
    tolua_error(tolua_S,"#ferror in function 'lua_cocos2dx_cw_CWCsb_setCsbFile'.",&tolua_err);
#endif

    return 0;
}
int lua_cocos2dx_cw_CWCsb_create(lua_State* tolua_S)
{
    int argc = 0;
    bool ok  = true;

#if COCOS2D_DEBUG >= 1
    tolua_Error tolua_err;
#endif

#if COCOS2D_DEBUG >= 1
    if (!tolua_isusertable(tolua_S,1,"ccui.CWCsb",0,&tolua_err)) goto tolua_lerror;
#endif

    argc = lua_gettop(tolua_S) - 1;

    if (argc == 0)
    {
        if(!ok)
        {
            tolua_error(tolua_S,"invalid arguments in function 'lua_cocos2dx_cw_CWCsb_create'", nullptr);
            return 0;
        }
        cocos2d::ui::CWCsb* ret = cocos2d::ui::CWCsb::create();
        object_to_luaval<cocos2d::ui::CWCsb>(tolua_S, "ccui.CWCsb",(cocos2d::ui::CWCsb*)ret);
        return 1;
    }
    luaL_error(tolua_S, "%s has wrong number of arguments: %d, was expecting %d\n ", "ccui.CWCsb:create",argc, 0);
    return 0;
#if COCOS2D_DEBUG >= 1
    tolua_lerror:
    tolua_error(tolua_S,"#ferror in function 'lua_cocos2dx_cw_CWCsb_create'.",&tolua_err);
#endif
    return 0;
}
int lua_cocos2dx_cw_CWCsb_constructor(lua_State* tolua_S)
{
    int argc = 0;
    cocos2d::ui::CWCsb* cobj = nullptr;
    bool ok  = true;

#if COCOS2D_DEBUG >= 1
    tolua_Error tolua_err;
#endif



    argc = lua_gettop(tolua_S)-1;
    if (argc == 0) 
    {
        if(!ok)
        {
            tolua_error(tolua_S,"invalid arguments in function 'lua_cocos2dx_cw_CWCsb_constructor'", nullptr);
            return 0;
        }
        cobj = new cocos2d::ui::CWCsb();
        cobj->autorelease();
        int ID =  (int)cobj->_ID ;
        int* luaID =  &cobj->_luaID ;
        toluafix_pushusertype_ccobject(tolua_S, ID, luaID, (void*)cobj,"ccui.CWCsb");
        return 1;
    }
    luaL_error(tolua_S, "%s has wrong number of arguments: %d, was expecting %d \n", "ccui.CWCsb:CWCsb",argc, 0);
    return 0;

#if COCOS2D_DEBUG >= 1
    tolua_error(tolua_S,"#ferror in function 'lua_cocos2dx_cw_CWCsb_constructor'.",&tolua_err);
#endif

    return 0;
}

static int lua_cocos2dx_cw_CWCsb_finalize(lua_State* tolua_S)
{
    printf("luabindings: finalizing LUA object (CWCsb)");
    return 0;
}

int lua_register_cocos2dx_cw_CWCsb(lua_State* tolua_S)
{
    tolua_usertype(tolua_S,"ccui.CWCsb");
    tolua_cclass(tolua_S,"CWCsb","ccui.CWCsb","ccui.Widget",nullptr);

    tolua_beginmodule(tolua_S,"CWCsb");
        tolua_function(tolua_S,"new",lua_cocos2dx_cw_CWCsb_constructor);
        tolua_function(tolua_S,"getCsbFile",lua_cocos2dx_cw_CWCsb_getCsbFile);
        tolua_function(tolua_S,"init",lua_cocos2dx_cw_CWCsb_init);
        tolua_function(tolua_S,"setCsbFile",lua_cocos2dx_cw_CWCsb_setCsbFile);
        tolua_function(tolua_S,"create", lua_cocos2dx_cw_CWCsb_create);
    tolua_endmodule(tolua_S);
    std::string typeName = typeid(cocos2d::ui::CWCsb).name();
    g_luaType[typeName] = "ccui.CWCsb";
    g_typeCast["CWCsb"] = "ccui.CWCsb";
    return 1;
}
TOLUA_API int register_all_cocos2dx_cw(lua_State* tolua_S)
{
	tolua_open(tolua_S);
	
	tolua_module(tolua_S,"cccw",0);
	tolua_beginmodule(tolua_S,"cccw");

	lua_register_cocos2dx_cw_CWCsb(tolua_S);

	tolua_endmodule(tolua_S);
	return 1;
}

