﻿#pragma once

#include "cocostudio/WidgetReader/WidgetReader.h"
#include "cocostudio/CocosStudioExport.h"

using namespace cocostudio;

class CWCsbReader : public WidgetReader
{
    DECLARE_CLASS_NODE_READER_INFO
        
public:
	CWCsbReader();
	virtual ~CWCsbReader();
        
	static CWCsbReader* getInstance();

	static void destroyInstance();
	/*
	virtual void setPropsFromJsonDictionary(cocos2d::ui::Widget* widget, const rapidjson::Value& options);

	virtual void setPropsFromBinary(cocos2d::ui::Widget* widget, CocoLoader* cocoLoader, stExpCocoNode*	pCocoNode);
	*/
	flatbuffers::Offset<flatbuffers::Table> createOptionsWithFlatBuffers(const tinyxml2::XMLElement* objectData,
		flatbuffers::FlatBufferBuilder* builder);

	void setPropsWithFlatBuffers(cocos2d::Node* node, const flatbuffers::Table* textCsbOptions);

    cocos2d::Node* createNodeWithFlatBuffers(const flatbuffers::Table* textCsbOptions);

};

